'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _electron = require('electron');

var _reactBootstrap = require('react-bootstrap');

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _chokidar = require('chokidar');

var _chokidar2 = _interopRequireDefault(_chokidar);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Post = function (_React$Component) {
  _inherits(Post, _React$Component);

  function Post(props) {
    _classCallCheck(this, Post);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Post).call(this, props));

    var win = _electron.remote.getCurrentWindow();
    _this.path = win.instance.path;
    _this.height = 0;
    _this.state = {
      content: '',
      autoResize: win.instance.autoResize
    };
    return _this;
  }

  _createClass(Post, [{
    key: 'createStateByDiff',
    value: function createStateByDiff(diff) {
      return Object.assign({}, this.state, diff);
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.handleFileUpdate.call(this);
      _chokidar2.default.watch(this.path).on('change', this.handleFileUpdate.bind(this));
      _chokidar2.default.watch(this.path).on('unlink', function () {
        _electron.remote.getCurrentWindow().close();
      });

      window.addEventListener('resize', this.handleResize.bind(this));
      this.height = window.innerHeight;
      _electron.remote.getCurrentWindow().show();
    }
  }, {
    key: 'handleFileUpdate',
    value: function handleFileUpdate() {
      var content = _fs2.default.readFileSync(this.path, 'utf8');
      if (content) {
        this.setState(this.createStateByDiff({ content: content }));
      }
    }
  }, {
    key: 'handleResize',
    value: function handleResize(event) {
      // scrollHeight: 入力内容全体
      // offsetHeight: 要素の大きさ
      var textarea = document.getElementById('editor');
      var areaCotentDiff = textarea.scrollHeight - textarea.offsetHeight;
      var resizeDiff = window.innerHeight - this.height;
      var newState = this.state;
      if (resizeDiff < 0) {
        if (areaCotentDiff > 0) {
          newState = this.createStateByDiff({ autoResize: false });
        }
      } else if (resizeDiff > 0) {
        if (areaCotentDiff <= 0) {
          newState = this.createStateByDiff({ autoResize: true });
        }
      }
      this.setState(newState);

      this.height = window.innerHeight;
    }
  }, {
    key: 'handleBlur',
    value: function handleBlur(event) {
      _fs2.default.writeFileSync(this.path, event.target.value);
    }
  }, {
    key: 'handleChange',
    value: function handleChange(event) {
      var textarea = event.target;

      if (this.state.autoResize) {
        var areaCotentDiff = textarea.scrollHeight - textarea.offsetHeight;
        if (areaCotentDiff > 0) {
          resizeTo(window.innerWidth, window.innerHeight + areaCotentDiff);
        }
      }

      this.setState(this.createStateByDiff({ content: textarea.value }));
    }
  }, {
    key: 'handlePlus',
    value: function handlePlus(event) {
      _electron.ipcRenderer.send('add-post', this.path);
    }
  }, {
    key: 'handleRemove',
    value: function handleRemove(event) {
      _fs2.default.unlink(this.path, function (err) {
        if (err) {
          throw new Error(err);
        }
      });

      _electron.remote.getCurrentWindow().close();
    }
  }, {
    key: 'render',
    value: function render() {
      var overflow = this.state.autoResize ? 'hidden' : 'auto';
      var textareaStyle = { overflow: overflow };

      _electron.remote.getCurrentWindow().instance.autoResize = this.state.autoResize;

      return _react2.default.createElement(
        'div',
        { className: 'post fix-height' },
        _react2.default.createElement(
          _reactBootstrap.Grid,
          null,
          _react2.default.createElement(
            _reactBootstrap.Row,
            null,
            _react2.default.createElement(
              'div',
              { className: 'header fix-width' },
              _react2.default.createElement(
                _reactBootstrap.Col,
                { xs: 6 },
                _react2.default.createElement('span', { className: 'fa fa-plus header-button dragholl',
                  onClick: this.handlePlus.bind(this)
                })
              ),
              _react2.default.createElement(
                _reactBootstrap.Col,
                { xs: 6 },
                _react2.default.createElement(
                  'div',
                  { className: 'remove-icon' },
                  _react2.default.createElement('span', { className: 'fa fa-remove pull-right header-button dragholl',
                    onClick: this.handleRemove.bind(this)
                  })
                )
              )
            )
          )
        ),
        _react2.default.createElement(
          'div',
          { className: 'body fix-height' },
          _react2.default.createElement('textarea', { id: 'editor', className: 'fix-width fix-height',
            style: textareaStyle,
            value: this.state.content,
            onChange: this.handleChange.bind(this),
            onBlur: this.handleBlur.bind(this)
          })
        )
      );
    }
  }]);

  return Post;
}(_react2.default.Component);

_reactDom2.default.render(_react2.default.createElement(Post, null), document.getElementById('container'));
//# sourceMappingURL=post.js.map
